
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Role_permissionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const role_permissions = await db.role_permissions.create(
            {
                id: data.id || undefined,
        
        resource: data.resource
        ||
        null
            ,
            
        action: data.action
        ||
        null
            ,
            
        allowed: data.allowed
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await role_permissions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return role_permissions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const role_permissionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                resource: item.resource
            ||
            null
            ,
            
                action: item.action
            ||
            null
            ,
            
                allowed: item.allowed
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const role_permissions = await db.role_permissions.bulkCreate(role_permissionsData, { transaction });

        // For each item created, replace relation files
        

        return role_permissions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const role_permissions = await db.role_permissions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.resource !== undefined) updatePayload.resource = data.resource;
        
        
        if (data.action !== undefined) updatePayload.action = data.action;
        
        
        if (data.allowed !== undefined) updatePayload.allowed = data.allowed;
        
        
        updatePayload.updatedById = currentUser.id;

        await role_permissions.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await role_permissions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return role_permissions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const role_permissions = await db.role_permissions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of role_permissions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of role_permissions) {
                await record.destroy({transaction});
            }
        });


        return role_permissions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const role_permissions = await db.role_permissions.findByPk(id, options);

        await role_permissions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await role_permissions.destroy({
            transaction
        });

        return role_permissions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const role_permissions = await db.role_permissions.findOne(
            { where },
            { transaction },
        );

        if (!role_permissions) {
            return role_permissions;
        }

        const output = role_permissions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organizations = await role_permissions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.resource) {
                where = {
                    ...where,
                resource: filter.resource,
            };
            }
            
            if (filter.action) {
                where = {
                    ...where,
                action: filter.action,
            };
            }
            
            if (filter.allowed) {
                where = {
                    ...where,
                allowed: filter.allowed,
            };
            }
            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.role_permissions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'role_permissions',
                        'resource',
                        query,
                    ),
                ],
            };
        }

        const records = await db.role_permissions.findAll({
            attributes: [ 'id', 'resource' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['resource', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.resource,
        }));
    }

    
};

